<script setup lang="ts">
  definePageMeta({
    middleware: ['presentation-pre-action'],
    layout: 'presentation',
  });

  const { isSelfService, isAppointmentInitializing } = useAppointment();
  const { currentSlide, stateLoaded, slidesCount } = usePresentation();
  const { loadLikeList } = useLikeList();
  const { self } = useParticipants();
  const { refreshCart } = useCart();
  const { publishInteraction } = useInteractions();
  const { lastGuideChangedLikes } = usePresentationState();
  const STATE_REFRESH_INTERVAL = 35 * 1000; // sec * ms = 60 sec;

  useIntervalFn(() => {
    publishInteraction({
      name: InteractionName.KEEP_ALIVE,
    });
  }, STATE_REFRESH_INTERVAL);

  onMounted(() => {
    refreshCart();
    loadLikeList();
  });

  watchDebounced(
    lastGuideChangedLikes,
    () => {
      if (isSelfService.value) return;
      if (lastGuideChangedLikes.value?.clientId === self.value?.attendeeId) {
        loadLikeList();
      }
    },
    { debounce: 1000, immediate: true },
  );
</script>

<template>
  <div v-if="!isAppointmentInitializing || isSelfService" class="relative min-h-full py-4 md:py-10">
    <DynamicPagesContainer />

    <CmsPage
      v-if="currentSlide?.cmsPageResult?.cmsPage"
      :key="`${currentSlide?.groupId}-${currentSlide?.sectionId}-${currentSlide?.pickedProductsCount}`"
      :content="currentSlide?.cmsPageResult?.cmsPage"
      :options="currentSlide"
      type="presentation"
    />

    <SwLoading
      v-else-if="!(slidesCount === 0 && stateLoaded)"
      :class="['text-primary absolute left-1/2 top-1/2 -translate-x-1/2 -translate-y-1/2 text-3xl']"
    />
  </div>
</template>
